unit UCalculate;

interface

uses SysUtils, UmainForm, UDataMod;

var
  WarnFile, TransFile,
  OutFile, FrqFile            : textfile;
  NUM, YY, YI                 : integer;
  Flag, WTdepth, Busy, Almost : boolean;
  Warn1, Warn2                : array [1..4] of boolean;
  EPU0, U, IRAI, IRBI         : array [1..4] of real;
  AC, BC, UC, DA, DB, DU,
  CAA, CAB, CAU, CAT, CIT,
  DRA, DRB, DWT, DWTI, DWT0,
  EFA, EFB, EFT, CSW, CSW0,
  EPAC, EPBC, EPUC,
  SCRA, SCRB, SCRU,
  SCRAI, SCRBI, SCRUI,
  SCRAM, SCRBM, SDAz, SDBz, SROz,
  SCU, SCL, SCT, SCA, SALT,
  PLA, PLB, PLT, PLU, SUA, SUB,
  ROP, TRP, AQP, ZDR, ZWL      : real;
  CiNa, ROTA0                  : integer;
  YRR : integer; {year index, temporary for debugging}
//for conversions
  AA, BB, AI, BI, BYP, DRR,
  FF,  HIG, HOG, IRA, IRB, RAI,
  PLC, SiU, SoU, SDA, SDB,
  SRI, SRO, STA, STB, STU,
  UU, WEL, WTC,  WEL0         : array [1..4] of real;
  CIR, CDW, DRC, ZIR,
  DIFP, DIFC,
  SCRA0, SCRB0, SCRU0,
  ZIC, ZIG, ZRA                : real;
//Transfer values
  DWTp, SCRAp, SCRBp, SCRUp,
  SCUp, SCLp, SCTp, SCAp, SALTp,
  AAp, BBp, UUp, DDp           : real;
  FIRSTp, KDp, KYp, YIp        : byte;
  PermanentFile                : string;

  procedure Calculations;
  procedure InitSettings;
  procedure Conversions;                               {for old Fortran symbols}
  procedure Opening;                        {open output files, writing headers}
  procedure Transfer;            {transfer data for annual calculations if Ky=1}
  procedure WriteOutputData (var AA,BB,BYP,IRA,IRB,PLC,UU,WEL : real);
  procedure TransValues;                              {part of WriteOutputData}
  procedure Frequency (var AA,BB,UU:real; var YR:integer);
  procedure WaterBalances (var AAy,BBy,BYPy,DRRy,EPAy,EPBy,EPUy,FFy,
            HIGy,HOGy,IRAy,IRBy,PLCy,RAIy,SDAy,SDBy,SRIy,SROy,STAy,STBy,STUy,
            UUy,WELy,WTCy : real);
  procedure AuxWBA (var AA1,BB1,EPA1,EPB1,EPU1,IRA1,IRB1,RAI1,SDA1,SDB1,
            SRI1,SRO1,STA1,STB1,STU1,UU1,ZZ1 : real);      {under WaterBalances}
  procedure AuxWBA1 (var CA,EP0,EP1,IR,RAIN,SD,ST,ZZ2 : real);    {under AuxWBA}
  procedure SaltBalances (var AAy,BBy,DRRy,FFy,HIGy,HOGy,IRAy,IRBy,PLCy,RAIy,
            SDAy,SDBy,SRIy,SROy,UUy,WELy : real);
  procedure AuxSB1 (var DOWNx,UPWAx,INFAx,INFBx,INFUx,RAINx,
            SCMAx,SCMBx,SCMUx,SCXx,SDAx,SDBx,SDLAx,SDLBx,SDLUx,
            SROx : real);                                   {under SaltBalances}
  procedure AuxSB2 (var AUB,SCR1,SCM1,SC01,SCR2,SCM2,SC02,TSC1,TSC2,TSI1,TSI2,
            TPL1,TPL2: real);                               {under SaltBalances}
  procedure AuxSB3 (var PLF,SCRAx,SCMAx,TSIx : real);       {under SaltBalances}
  procedure AuxSB4A (var PLC,SCTMx,TSPx,VDDx,VUSx : real);  {under SaltBalances}
  procedure AuxSB4B (var PLC,SCAx,SCLx,SCLMx,SCUx,SCUMx,TSPx,
            VDDx,VUSx : real);                              {under SaltBalances}
  procedure AuxSB5 (var HIG,HOG,PLC,PLF,SCLMx,SCTMx,VDDx,VUSx,WELx,
            ZIGx,ZIRx : real);                              {under SaltBalances}
  procedure Efficiency (var AAy,BBy,EPAy,EPBy,IRAy,IRBy,RAIy : real);

  implementation

procedure Calculations;
{---------------------}
label 2;
var J : integer; AB : real;

begin with DataMod do
begin
//Inital settings
  InitSettings;
//Temporary conversions using old Fortran symbols,
//later to be replaced by DataMod symbols
  Conversions;
//Opening Warning file, opening/reading a transfer file if required,
  Opening;
//transfer data for annual calculations if Ky=1
  Transfer;
//Writing initial data to the output file and frequency file
  IF YI=0 THEN          {YI=0 only in the first month}
  begin
    FOR J:=1 to Ns do
    begin
      YY:=J;
      EPU0[J]:=EpU[J];            {initial evaporation from unirrigated U land}
//Writing initial data of year 0 to *.RES and *.FRQ
      WriteOutputData (AA[J],BB[J],BYP[J],IRA[J],IRB[J],PLC[J],
                       UU[J],WEL[J]);
    end;
  end; {IF YI=0 THEN}

  YY:=1;

//Determining water balances and a new depth of the watertable through
//procedure Waterbalances with secondary subroutines
    BYP[YY]:=Io[YY];
    AB := AA[YY] + BB[YY];
    if AA[YY]=-1 then AB:=BB[YY];
    if BB[YY]=-1 then AB:=AA[YY];
    if Kd=1 then
       IRA[YY]:=IaA[YY]+(Gu[YY]+Fw[YY]*Gw[YY])/AB
    else
       IRA[YY]:=IaA[YY]+(Fw[YY]*Gw[YY])/AB;
    if Kd=1 then
       IRB[YY]:=IaB[YY]+(Gu[YY]+Fw[YY]*Gw[YY])/AB
    else
       IRB[YY]:=IaB[YY]+(Fw[YY]*Gw[YY])/AB;
    PLC[YY]:=Lc[YY];
    DWT0:=DWT;
    Waterbalances (AA[YY],BB[YY],BYP[YY],DRR[YY],
                  EPA[YY],EPB[YY],EPU[YY],FF[YY],HIG[YY],HOG[YY],
                  IRA[YY],IRB[YY],PLC[YY],RAI[YY],SDA[YY],SDB[YY],
                  SRI[YY],SRO[YY],STA[YY],STB[YY], STU[YY],UU[YY],
                  WEL[YY],WTC[YY]);

//Salt balances and new salinities with secondary subroutines
    SCRA0:=SCRA;
    SCRB0:=SCRB;
    SCRU0:=SCRU;
    SaltBalances (AA[YY],BB[YY],DRR[YY],FF[YY],HIG[YY],HOG[YY],
                  IRA[YY],IRB[YY],PLC[YY],RAI[YY],SDAz,SDBz,
                  SRI[YY],SROz,UU[YY],WEL[YY]);

//Determining field irrigation efficiencies, canal irrigation
//efficiencies, and sufficiencies of irrigation water
    Efficiency (AA[YY],BB[YY],EPA[YY],EPB[YY],IRA[YY],IRB[YY],RAI[YY]);

//Writing output data to the output file, calculating and writing
//frequency distributions through subroutine Frequency
    WriteOutputData (AA[YY],BB[YY],BYP[YY],IRA[YY],IRB[YY],PLC[YY],
                     UU[YY],WEL[YY]);

    IF (DWT>Dr+Dx+Dq) THEN
      WTDepth:=true;

//Continuing the calculations for the next season
    DWT0:=DWT;                                   {new initial watertable depth}

2: closefile (OutFile);
  closefile (FrqFile);
  closefile (WarnFile);

end; {with DataMod do}
end; {procedure Calculations}
{---------------------------}


procedure InitSettings;
{---------------------}
var I:byte;

begin with DataMod do
begin
  Flag:=false;
  Busy:=false;
  Almost:=false;
  for I:=1 to Ns do Warn1[I]:=false;
  for I:=1 to Ns do Warn2[I]:=false;
  DWTI:=Dw0;
  DWT0:=Dw0;
  SALT:=0;
  if DataMod.MonthNr=1 then CSW0:=Cic;
  NUM:=Nm;
  For I:=1 to Ns do
  begin
    AI[I]:=A[I];                                               {initial A area}
    BI[I]:=B[I];                                               {initial B area}
    IRAI[I]:=IaA[I];                             {initial irrigation of A area}
    IrBI[I]:=IaB[I];                             {initial irrigation of A area}
    WEL0[I]:=Gw[I];                                {initial pumping from wells}
  end;

end; {with DataMod do}
end; {procedure InitSettings}
{---------------------------}


//Temporary conversions using old Fortran symbols,
//later to be replaced by DataMod symbols
procedure Conversions;
{-------------------}
var ii : byte;

begin with DataMod do
begin
//reals
//  CIR:=Cic;
  CDW:=Dc;
  DWT:=Dw0;
  SCA:=Cq0;
  SCL:=CxB0;
  SCT:=Cx0;
  SCU:=CxA0;
  SCRA:=CA0;
  SCRB:=CB0;
  SCRU:=CU0;
  ZIC:=Cic;
  ZIG:=Ch;
  ZRA:=Cp;
//real arrays
  for ii:=1 to Ns do
  begin
    AA[ii]:=A[ii];
    BB[ii]:=B[ii];
    BYP[ii]:=Io[ii];
    if Kd=1 then DRR[ii]:=Gu[ii]
    else DRR[ii]:=0;
    FF[ii]:=Fw[ii];
    HIG[ii]:=Gi[ii];
    HOG[ii]:=Go[ii];
    IRA[ii]:=IaA[ii];
    IRB[ii]:=IaB[ii];
    RAI[ii]:=Pp[ii];
    PLC[ii]:=Lc[ii];
    SDA[ii]:=SoA[ii];
    SDB[ii]:=SoB[ii];
    SRI[ii]:=SiU[ii];
    SRO[ii]:=SoU[ii];
    STA[ii]:=FsA[ii];
    STB[ii]:=FsB[ii];
    STu[ii]:=FsU[ii];
    UU[ii]:=U[ii];
    WEL[ii]:=Gw[ii];
    WTC[ii]:=Frd[ii];
  end;

end; {with DataMod do}
end; {procedure Conversions}
{--------------------------}


//To open warning, output (*.Out) and *.Frq files, write headers
procedure Opening;
{----------------}
var AuxFile : string;
begin with DataMod do
begin

//Opening warning file
  Assignfile(WarnFile, 'Warning.lst');
  rewrite (WarnFile);
  writeln (WarnFile,' THE FOLLOWING RUNTIME WARNINGS ARE GIVEN:');
//Opening the *.RES output file
  FileName := ChangeFileExt(FileName,'.res');
  if Ky=1 then FileName := ChangeFileExt(PermanentFile,'.res');
  Assignfile (OutFile, FileName);
  IF (Ky=0) OR ((Ky=1) AND (YI=0)) THEN
     Rewrite (OutFile);
  IF (Ky=1) AND (YI>0) THEN
     Append(OutFile);
//Opening the *.FRQ output file
  FileName := ChangeFileExt(FileName,'.frq');
  if Ky=1 then FileName := ChangeFileExt(PermanentFile,'.frq');
  Assignfile (FrqFile, FileName);
  IF (Ky=0) OR ((Ky=1) AND (YI=0)) THEN
      Rewrite (FrqFile);
  IF (Ky=1) AND (YI>0) THEN
     Append(FrqFile);

//Initially writing a header in output file
  IF YI=0 THEN
  begin
    writeln (OutFile, ' SALTMOD: A predictive computation method for'+
                      ' soil and groundwater,');
    writeln (OutFile, ' salinity and the watertable depth in'+
                      ' agricultural lands using');
    writeln (OutFile, ' varying hydrologic conditions and'+
                      ' watermanagement options.');
    writeln (OutFile, ' The first program was developed in Fortran by'+
                      ' R.J.Oosterbaan and');
    writeln (OutFile, ' Isabel de Lima at ILRI, Wageningen The Netherlands.');
    writeln (OutFile, ' The first user menu in TurboPscal was developed'+
                      ' by Henk Ramnandanlal');
    writeln (OutFile, ' and Rob Kselik.');
    writeln (OutFile, ' The first Windows version 1.0 of August 2006 was made'+
                      ' by Oosterbaan,');
    writeln (OutFile, ' and updated regularly.');
    writeln (OutFile);
    AuxFile:=changefileext (FileName,'.RES');
    writeln (OutFile, ' Name of this output (result) file: ',AuxFile);
    AuxFile:=changefileext (FileName,'.INP');
    writeln (OutFile, ' Name of input (data) file used   : ',AuxFile);
    if (Ky=1) then
        writeln (OutFile,' Calculations were done by timesteps.')
    else
        writeln (OutFile,' Calculations were done for all years in one go.');
  end; {IF YI=0 THEN}

end; {with DataMod do}
end; {procedure Opening}
{----------------------}


procedure Transfer; {Using transfer data if needed (Ky=1, annual calculations)}
{-----------------}
begin with DataMod do
begin
  IF Ky=1 THEN
  BEGIN
    NUM:=1;
    if FIRST=1 then
       FIRST:=0
    else
    begin
//Resetting transfer values;
      FIRST:=FIRSTp;
      DWT:=DWTp;
      SCRA:=SCRAp;
      SCRB:=SCRBp;
      SCRU:=SCRUp;
      SCU:=SCUp;
      SCL:=SCLp;
      SCT:=SCTp;
      SCA:=SCAp;
      SALT:=SALTp;
      AA[1]:=AAp;
      BB[1]:=BBp;
      UU[1]:=UUp;
      Dd:=DDp;
      Kd:=KDp;
      YI:=YIp;
      Ky:=KYp;
//Checking change of subsurface drainage system
      IF(KDp=0) AND (Kd=1) THEN
      begin
        SCU:=Cxa0;
        SCL:=Cxb0;
      end;
      IF (KDp=1) AND (Kd=1) THEN
         IF (Dd>=DDp) THEN
             SCU:=((DDp-Dr)*SCU+(Dd-DDp)*SCL)/(Dd-Dr)
         ELSE
             SCL:=((Dx-DDp)*SCL+(DDp-Dd)*SCU)/(Dx-Dr);
    end; {if FIRST<>1 then}
  END; {if Ky=1 then}

end; {with DataMod do}
end; {procedure Transfer}
{-----------------------}


procedure WriteOutputData (var AA,BB,BYP,IRA,IRB,PLC,UU,WEL : real);
{---------------------------------------------------------------------}
var YR : integer;
    AIR, BIR : real;
    TmpFile : string;
begin with DataMod do
begin

//Writing year and season in the output file
  YR:=YI;
  WRITELN (OUTFILE);
  TmpFile:=changefileext (FileName,'.INP');
  if DataMod.TimeStep='Month' then
     Writeln (OutFile,'  MONTH: ',YR:4,'   Name of input (data) file used:',
              TmpFile);
  if DataMod.TimeStep='Week' then
     Writeln (OutFile,'   WEEK: ',YR:4,'   Name of input (data) file used:',
              TmpFile);
  if DataMod.TimeStep='Day' then
     Writeln (OutFile,'   DAY: ',YR:4,'   Name of input (data) file used:',
              TmpFile);
  Writeln (OutFile,'  **********');
  IF (Ky=1) AND (YY=NS) THEN YI:=YI+1;

//Canal/field irrigation
  IF AA<0.001 THEN AA:=0;
  IF BB<0.001 THEN BB:=0;
  AIR:=IRA;
  BIR:=IRB;
  IF AA<0.001 THEN AIR:=0;
  IF BB<0.001 THEN BIR:=0;
  IF (YR=0) THEN  CIT:=PLC+IRA*AA+IRB*BB;
  IF (IRA+IRB<0.001) THEN CIT:=0;
  IF (IRA+IRB<0.001) THEN CIR:=0;
	IF (AA>0.001) AND (BB>0.001) THEN
      Writeln (OutFile,'  It  = ',format('%10.3e',[CIT]),'    Is  = ',
               format('%10.3e',[CIR]),'    IaA = ',format('%10.3e',[AIR]),
               '    IaB = ',format('%10.3e',[BIR]));
	IF (AA>0.001) AND (BB<0.001) THEN
      Writeln (OutFile,'  It  = ',format('%10.3e',[CIT]),'    Is  = ',
               format('%10.3e',[CIR]),'    IaA = ',format('%10.3e',[AIR]),
               '    IaB = ','     -    ');
	IF (AA<0.001) AND (BB>0.001) THEN
      Writeln (OutFile,'  It  = ',format('%10.3e',[CIT]),'    Is  = ',
               format('%10.3e',[CIR]),'    IaA = ','     -    ',
               '    IaB = ',format('%10.3e',[BIR]));
	IF (AA<0.001) AND (BB<0.001) THEN
      Writeln (OutFile,'  It  = ','     -    ','    Is  = ',
               '     -    ','    IaA = ','     -    ',
               '    IaB = ','     -    ');

//Efficiencies, sufficiencies, EaU (evaporation unirrigated U-land), bypass
	IF (AA>0.001) AND (BB>0.001) THEN
  BEGIN
      Writeln (OutFile,'  FfA = ',format('%10.3e',[EFA]),'    FfB = ',
               format('%10.3e',[EFB]),'    FfT = ',format('%10.3e',[EFT]),
               '    Io  = ',format('%10.3e',[BYP]));
      IF UU>0.001 THEN
         Writeln (OutFile,'  JsA = ',format('%10.3e',[SUA]),'    JsB = ',
                  format('%10.3e',[SUB]),'    EaU = ',format('%10.3e',[EPUC]))
      ELSE
         Writeln (OutFile,'  JsA = ',format('%10.3e',[SUA]),'    JsB = ',
                  format('%10.3e',[SUB]),'    EaU = ','     -    ');
  END;
	IF (AA>0.001) AND (BB<0.001) THEN
  BEGIN
      Writeln (OutFile,'  FfA = ',format('%10.3e',[EFA]),'    FfB = ',
               '     -    ','    FfT = ',format('%10.3e',[EFT]),
               '    Io  = ',format('%10.3e',[BYP]));
      IF UU>0.001 THEN
         Writeln (OutFile,'  JsA = ',format('%10.3e',[SUA]),'    JsB = ',
                  '     -    ','    EaU = ',format('%10.3e',[EPUC]))
      ELSE
         Writeln (OutFile,'  JsA = ',format('%10.3e',[SUA]),'    JsB = ',
                  '     -    ','    EaU = ','     -    ');
  END;
	IF (AA<0.001) AND (BB>0.001) THEN
  BEGIN
      Writeln (OutFile,'  FfA = ','     -    ','    FfB = ',
               format('%10.3e',[EFB]),'    FfT = ',format('%10.3e',[EFT]),
               '    Io  = ',format('%10.3e',[BYP]));
      IF UU>0.001 THEN
         Writeln (OutFile,'  JsA = ','     -    ','    JsB = ',
                  format('%10.3e',[SUB]),'    EaU = ',format('%10.3e',[EPUC]))
      ELSE
         Writeln (OutFile,'  JsA = ','     -    ','    JsB = ',
                  format('%10.3e',[SUB]),'    EaU = ','     -    ');
  END;
	IF (AA<0.001) AND (BB<0.001) THEN
  BEGIN
      Writeln (OutFile,'  FfA = ','     -    ','    FfB = ',
               '     -    ','    FfT = ','     -    ',
               '    Io  = ',format('%10.3e',[BYP]));
      Writeln (OutFile,'  JsA = ','     -    ','    JsB = ',
               '     -    ','    EaU = ',format('%10.3e',[EPUC]));
  END;

//Determining net values of percolation and capillary rise
  if (AA>0.001) then
  begin
    if (caa>=pla) then
    begin
      caa:=caa-pla;
      pla:=0;
    end else
    begin
      pla:=pla-caa;
      caa:=0;
    end;
  end else
  begin
	  caa:=0;
	  pla:=0;
	end;
  if (BB>0.001) then
  begin
    if (cab>=plb) then
    begin
      cab:=cab-plb;
      plb:=0;
    end else
    begin
      plb:=plb-cab;
      cab:=0;
    end;
  end else
  begin
	  cab:=0;
	  plb:=0;
	end;
  if (UU>0.001) then
  begin
    if (cau>=plu) then
    begin
      cau:=cau-plu;
      plu:=0;
    end else
    begin
      plu:=plu-cau;
      cau:=0;
    end;
  end else
  begin
	  cau:=0;
	  plu:=0;
	end;

//Writing percolation and capillary rise
  PLT:=AA*PLA+BB*PLB+UU*PLU;
  CAT:=AA*CAA+BB*CAB+UU*CAU;
  IF  (UU>0.001) THEN
  BEGIN
  	IF (AA>0.001) AND (BB>0.001) THEN
    BEGIN
      Writeln (OutFile,'  LrA = ',format('%10.3e',[PLA]),'    LrB = ',
               format('%10.3e',[PLB]),'    LrU = ',format('%10.3e',[PLU]),
               '    LrT = ',format('%10.3e',[PLT]));
      Writeln (OutFile,'  RrA = ',format('%10.3e',[CAA]),'    RrA = ',
               format('%10.3e',[CAB]),'    RrU = ',format('%10.3e',[CAU]),
               '    RrT = ',format('%10.3e',[CAT]));
    END;
  	IF (AA>0.001) AND (BB<0.001) THEN
    BEGIN
      Writeln (OutFile,'  LrA = ',format('%10.3e',[PLA]),'    LrB = ',
               '     -    ','    LrU = ',format('%10.3e',[PLU]),
               '    LrT = ',format('%10.3e',[PLT]));
      Writeln (OutFile,'  RrA = ',format('%10.3e',[CAA]),'    RrB = ',
               '     -    ','    RrU = ',format('%10.3e',[CAU]),
               '    RrT = ',format('%10.3e',[CAT]));
    END;
  	IF (AA<0.001) AND (BB>0.001) THEN
    BEGIN
        Writeln (OutFile,'  LrA = ','     -    ','    LRB = ',
                 format('%10.3e',[PLB]),'    LrU = ',format('%10.3e',[PLU]),
                 '    RrT = ',format('%10.3e',[PLT]));
        Writeln (OutFile,'  RrA = ','     -    ','    RrB = ',
                 format('%10.3e',[CAB]),'    RrU = ',format('%10.3e',[CAU]),
                 '    RrT = ',format('%10.3e',[CAT]));
    END;
   	IF (AA<0.001) AND (BB<0.001) THEN
    BEGIN
      Writeln (OutFile,'  LrA = ','     -    ','    LRB = ',
               '     -    ','    LrU = ',format('%10.3e',[PLU]),
               '    RrT = ',format('%10.3e',[PLT]));
      Writeln (OutFile,'  RrA = ','     -    ','    RrB = ',
               '     -    ','    RrU = ',format('%10.3e',[CAU]),
               '    RrT = ',format('%10.3e',[CAT]));
    END;
  END;
  IF  (UU<0.001) THEN
  BEGIN
  	IF (AA>0.001) AND (BB>0.001) THEN
    BEGIN
      Writeln (OutFile,'  LrA = ',format('%10.3e',[PLA]),'    LrB = ',
               format('%10.3e',[PLB]),'    LrU = ','     -    ',
               '    LrT = ',format('%10.3e',[PLT]));
      Writeln (OutFile,'  RrA = ',format('%10.3e',[CAA]),'    RrB = ',
               format('%10.3e',[CAB]),'    RrU = ','     -    ',
               '    RrT = ',format('%10.3e',[CAT]));
    END;
  	IF (AA>0.001) AND (BB<0.001) THEN
    BEGIN
      Writeln (OutFile,'  LrA = ',format('%10.3e',[PLA]),'    LrB = ',
               '     -    ','    LrU = ','     -    ',
               '    LrT = ',format('%10.3e',[PLT]));
      Writeln (OutFile,'  RrA = ',format('%10.3e',[CAA]),'    RrB = ',
               '     -    ','    RrU = ','     -    ',
               '    RrT = ',format('%10.3e',[CAT]));
    END;
  	IF (AA<0.001) AND (BB>0.001) THEN
    BEGIN
      Writeln (OutFile,'  LrA = ','     -    ','    LRB = ',
               format('%10.3e',[PLB]),'    LrU = ','     -    ',
               '    RrT = ',format('%10.3e',[PLT]));
      Writeln (OutFile,'  RrA = ','     -    ','    RrB = ',
               format('%10.3e',[CAB]),'    RrU = ','     -    ',
               '    RrT = ',format('%10.3e',[CAT]));
    END;
  END;

//Drain/well discharge, watertable depth
  IF Kd=1 THEN
     Writeln (OutFile,'  Gd  = ',format('%10.3e',[DRC]),'    Ga  = ',
              format('%10.3e',[DRA]),'    Gb  = ',format('%10.3e',[DRB]))
  ELSE
     Writeln (OutFile,'  Gd  = ','     -    ','    Ga  = ',
              '     -    ','    Gb  = ','     -    ');
  if (DWT<0) and (DWT>-0.001) then DWT:=-0.001;
  if (DWT>0) and (DWT<0.001) then DWT:=0.001;
  IF Salt>0.001 THEN
     Writeln (OutFile,'  Gw  = ',format('%10.3e',[WEL]),'    Dw  = ',
              format('%10.3e',[DWT]),'    Zs  = ',format('%10.3e',[SALT]))
  ELSE
     Writeln (OutFile,'  Gw  = ',format('%10.3e',[WEL]),'    Dw  = ',
              format('%10.3e',[DWT]),'    Zs  = ','     -    ');

//Seasonal and permanent area fractions
  Writeln (OutFile,'  A   = ',format('%10.3e',[AA]),'    B   = ',
           format('%10.3e',[BB]),'    U   = ',format('%10.3e',[UU]));

//Soil salinities in rootzone, afhankelijk van Kr
	 IF SCRA<0.001 THEN SCRA:=0;
	 IF SCRB<0.001 THEN SCRB:=0;
	 IF SCRU<0.001 THEN SCRU:=0;
   IF (UC<0.001) THEN UC:=0;
   AC:=AA;
   BC:=BB;
   UC:=UU;
   IF Kr=0 THEN
   BEGIN
	   IF (AC>0.001) AND (BC>0.001) AND (UC>0.001) THEN
        Writeln (OutFile,'  CrA = ',format('%10.3e',[SCRA]),'    CrB = ',
                 format('%10.3e',[SCRB]),'    CrU = ',format('%10.3e',[SCRU]),
                 '    Cr4 = ','     -    ');
	   IF (AC<0.001) AND (BC>0.001) AND (UC>0.001) THEN
        Writeln (OutFile,'  CrA = ','     -    ','    CrB = ',
                 format('%10.3e',[SCRB]),'    CrU = ',format('%10.3e',[SCRU]),
                 '    Cr4 = ','     -    ');
	   IF (AC>0.001) AND (BC<0.001) AND (UC>0.001) THEN
        Writeln (OutFile,'  CrA = ',format('%10.3e',[SCRA]),'    CrB = ',
                 '     -    ','    CrU = ',format('%10.3e',[SCRU]),
                 '    Cr4 = ','     -    ');
	   IF (AC>0.001) AND (BC>0.001) AND (UC<0.001) THEN
        Writeln (OutFile,'  CrA = ',format('%10.3e',[SCRA]),'    CrB = ',
                 format('%10.3e',[SCRB]),'    CrU = ','     -    ',
                 '    Cr4 = ','     -    ');
	   IF (AC>0.001) AND (BC<0.001) AND (UC<0.001) THEN
        Writeln (OutFile,'  CrA = ',format('%10.3e',[SCRA]),'    CrB = ',
                 '     -    ','    CrU = ','     -    ',
                 '    Cr4 = ','     -    ');
	   IF (AC<0.001) AND (BC>0.001) AND (UC<0.001) THEN
        Writeln (OutFile,'  CrA = ','     -    ','    CrB = ',
                 format('%10.3e',[SCRB]),'    CrU = ','     -    ',
                 '    Cr4 = ','     -    ');
	   IF (AC<0.001) AND (BC<0.001) AND (UC>0.001) THEN
        Writeln (OutFile,'  CrA = ','     -    ','    CrB = ',
                 '     -    ','    CrU = ',format('%10.3e',[SCRU]),
                 '    Cr4 = ','     -    ');
   END; {IF Kr=0 THEN}

//Other salinities
   IF Kd=1 THEN
      Writeln (OutFile,'  Cxf = ','     -    ','    Cxa = ',
               format('%10.3e',[SCU]),'    Cxb = ',format('%10.3e',[SCL]),
               '    Cqf = ',format('%10.3e',[SCA]))
   ELSE
      Writeln (OutFile,'  Cxf = ',format('%10.3e',[SCT]),'    Cxa = ',
               '     -    ','    Cxb = ','     -    ',
               '    Cqf = ',format('%10.3e',[SCA]));
   IF (Kd=1) AND (CiNa=0) THEN
   BEGIN
     IF WEL>0.001 THEN
        Writeln (OutFile,'  Ci  = ',format('%10.3e',[ZIR]),'    Cd  = ',
                 format('%10.3e',[ZDR]),'    Cw  = ',format('%10.3e',[ZWL]))
     ELSE
        Writeln (OutFile,'  Ci  = ',format('%10.3e',[ZIR]),'    Cd  = ',
                 format('%10.3e',[ZDR]),'    Cw  = ','     -    ');
   END;
   IF (Kd=1) AND (CiNa=1) THEN
   BEGIN
     IF WEL>0.001 THEN
        Writeln (OutFile,'  Ci  = ','     -    ','    Cd  = ',
                 format('%10.3e',[ZDR]),'    Cw  = ',format('%10.3e',[ZWL]))
     ELSE
        Writeln (OutFile,'  Ci  = ','     -    ','    Cd  = ',
                 format('%10.3e',[ZDR]),'    Cw  = ','     -    ');
   END;
   IF (Kd=0) AND (CiNa=0) THEN
   BEGIN
     IF WEL>0.001 THEN
      Writeln (OutFile,'  Ci  = ',format('%10.3e',[ZIR]),'    Cd  = ',
               '     -    ','    Cw  = ',format('%10.3e',[ZWL]))
     ELSE
      Writeln (OutFile,'  Ci  = ',format('%10.3e',[ZIR]),'    Cd  = ',
               '     -    ','    Cw  = ','     -    ');
   END;
   IF (Kd=0) AND (CiNa=1) THEN
   BEGIN
     IF WEL>0.001 THEN
        Writeln (OutFile,'  Ci  = ','     -    ','    Cd  = ',
                 '     -    ','    Cw  = ',format('%10.3e',[ZWL]))
     ELSE
        Writeln (OutFile,'  Ci  = ','     -    ','    Cd  = ',
                 '     -    ','    Cw  = ','     -    ');
   END;
   Writeln (OutFile,' #');

//Calculating and writing frequency distributions of soil salinities
  Frequency (AA,BB,UU,YR);
  WRITELN (OutFile);

//Preparing transfer values if required
  IF (Ky=1) THEN
     IF (YY=NS) THEN
     BEGIN
       IF Kr=1 THEN
       BEGIN
          IF UU<0.999 THEN SCRA:=(SCRA*(1-UC)-SCRU*(UU-UC))/(AA+BB);
          SCRB:=SCRA;
       END;
       IF Kr=2 THEN
       BEGIN
          IF AA<0.999 THEN SCRB:=(SCRB*(1-AC)-SCRA*(AA-AC))/(BB+UU);
          SCRU:=SCRA;
       END;
       IF Kr=3 THEN
       BEGIN
          IF BB<0.999 THEN SCRA:=(SCRA*(1-BC)-SCRB*(BB-BC))/(AA+UU);
          SCRU:=SCRA;
       END;
       IF Kr=4 THEN
       BEGIN
         SCRB:=SCRA;
         SCRU:=SCRA;
       END;
       IF (Kd=1) AND (Dx>0.001) THEN
           SCT:=((Dd-Dr)*SCU+(Dx+Dr-Dd)*SCL)/Dx;
       IF Kd=0 THEN
       BEGIN
         SCU:=SCT;
         SCL:=SCT;
         Dd:=Dr;
       END;
//Setting transfer values
    TransValues;
  END;{IF (Ky=1) THEN}

end; {with DataMod do}
end; {WriteOutputData}
{--------------------}


procedure TransValues;                                {part of WriteOutputData}
{--------------------}
begin with DataMod do
begin
  FIRSTp:=FIRST;
  DWTp:=DWT;
  SCRAp:=SCRA;
  SCRBp:=SCRB;
  SCRUp:=SCRU;
  SCUp:=SCU;
  SCLp:=SCL;
  SCTp:=SCT;
  SCAp:=SCA;
  SALTp:=SALT;
  AAp:=AA[1];
  BBp:=BB[1];
  UUp:=UU[1];
  DDp:=Dd;
  KDp:=Kd;
  YIp:=YI;
  KYp:=Ky;
end; {with DataMpd do}
end; {procedure TransValues}
{--------------------------}


procedure Frequency (var AA,BB,UU:real; var YR:integer);
{---------------------------------------------------------}
var ALF, BET, A1, A2, A3, A4, B1, B2, B3, B4, U1, U2, U3, U4 : real;
begin
with DataMod do
  begin
    IF AREA<=100 THEN
    BEGIN
      ALF:=0.25;
      BET:=0.84;
    END ELSE
    IF AREA<=1000 THEN
    BEGIN
      ALF:=0.32;
      BET:=0.81;
    END ELSE
    IF AREA<=1000 THEN
    BEGIN
      ALF:=0.41;
      BET:=0.76;
    END ELSE
    BEGIN
      ALF:=0.52;
      BET:=0.69;
    END;

//Calculating the cumulative frequencies at 20%, 40%, 60%, and 80%
    A1:=SCRA*(BET-ALF*LN(-LN(0.2)));
    A2:=SCRA*(BET-ALF*LN(-LN(0.4)));
    A3:=SCRA*(BET-ALF*LN(-LN(0.5)));
    A4:=SCRA*(BET-ALF*LN(-LN(0.8)));
    B1:=SCRB*(BET-ALF*LN(-LN(0.2)));
    B2:=SCRB*(BET-ALF*LN(-LN(0.4)));
    B3:=SCRB*(BET-ALF*LN(-LN(0.5)));
    B4:=SCRB*(BET-ALF*LN(-LN(0.8)));
    U1:=SCRU*(BET-ALF*LN(-LN(0.2)));
    U2:=SCRU*(BET-ALF*LN(-LN(0.4)));
    U3:=SCRU*(BET-ALF*LN(-LN(0.5)));
    U4:=SCRU*(BET-ALF*LN(-LN(0.8)));

//Writing frequency
    IF Kr=0 THEN
    BEGIN
      IF (AA>0.001) AND (SCRA>0.001) THEN
      BEGIN
        WRITELN (OutFile,'Cumulative frequency distribution of CrA');
        WRITELN (OutFile,'  20%   ',format('%10.3e',[A1]),'  40%   ',
              format('%10.3e',[A2]),'  60%   ',format('%10.3e',[A3]),'  80%   ',
              format('%10.3e',[A4]));
      END ELSE
      BEGIN
        WRITELN (OutFile);
        Writeln (OutFile);
      END;
      IF (BB>0.001) AND (SCRB>0.001) THEN
      BEGIN
        WRITELN (OutFile,'Cumulative frequency distribution of CrB');
        WRITELN (OutFile,'  20%   ',format('%10.3e',[B1]),'  40%   ',
              format('%10.3e',[B2]),'  60%   ',format('%10.3e',[B3]),'  80%   ',
              format('%10.3e',[B4]));
      END ELSE
      BEGIN
        WRITELN (OutFile);
        writeln (OutFile);
      END;
      IF (UU>0.001) AND (SCRU>0.001) THEN
      BEGIN
        WRITELN (OutFile,'Cumulative frequency distribution of CrU');
        WRITELN (OutFile,'  20%   ',format('%10.3e',[U1]),'  40%   ',
              format('%10.3e',[U2]),'  60%   ',format('%10.3e',[U3]),'  80%   ',
              format('%10.3e',[U4]));
      END ELSE
      BEGIN
        WRITELN (OutFile);
        Writeln (OutFile);
      END;
    END;

//Writing frequencies to *.FRQ
   IF (YR=0) AND (YY=1) THEN
   BEGIN
     WRITELN (FrqFile,'  FREQUENCY DISTRIBUTION OF SOIL SALINITY');
     WRITELN (FrqFile,'  "(meant for"',' spreadsheet use)');
     WRITELN (FrqFile);
     IF (YY=1) and (DataMod.TimeStep='Month') THEN
       WRITELN (FrqFile,'"MONTH:  ',YR:4,'"',' - ',' - ',' "Name of" ',
                ' "input" ',' "file:" ',FileName);
     IF (YY=1) and (DataMod.TimeStep='Week') THEN
       WRITELN (FrqFile,'" WEEK:  ',YR:4,'"',' - ',' - ',' "Name of" ',
                ' "input" ',' "file:" ',FileName);
     IF (YY=1) and (DataMod.TimeStep='Day') THEN
       WRITELN (FrqFile,'" DAY:  ',YR:4,'"',' - ',' - ',' "Name of" ',
                ' "input" ',' "file:" ',FileName);
    END;

    IF (YR>0) OR ((YR=0) AND (YY>1)) THEN
    BEGIN
      IF (YY=1) and (DataMod.TimeStep='Month') THEN
          WRITELN (FrqFile,'"Month:  ',YR:4,'"');
      IF (YY=1) and (DataMod.TimeStep='Week ') THEN
          WRITELN (FrqFile,'" Week:  ',YR:4,'"');
      IF (YY=1) and (DataMod.TimeStep='Day ') THEN
          WRITELN (FrqFile,'" Day:  ',YR:4,'"');
    END;
    WRITELN (FrqFile,'- ','- ','- ','           Cumulative',
             ' "frequency of"',' "soil salinity"');
    WRITELN (FrqFile,'-',' Salinity   ',' -  ',
             '  20%   ','    40%   ','    60%   ','    80%    ');

    IF (Kr=4) THEN
       WRITELN (FrqFile,'- ',' Cr4    ','    -',format('%10.3e',[A1]),
       format('%10.3e',[A2]),format('%10.3e',[A3]),format('%10.3e',[A4]));

    IF (Kr=1) THEN
    BEGIN
      if (SCRA>0.001) then
         WRITELN (FrqFile,'- ',' C1*    ','    -',format('%10.3e',[A1]),
         format('%10.3e',[A2]),format('%10.3e',[A3]),format('%10.3e',[A4]));
      if (SCRU>0.001) then
         WRITELN (FrqFile,'- ',' CrU    ','    -',format('%10.3e',[U1]),
         format('%10.3e',[U2]),format('%10.3e',[U3]),format('%10.3e',[U4]));
    END;

    IF (Kr=2) THEN
    BEGIN
      if (SCRA>0.001) then
         WRITELN (FrqFile,'- ',' C2*    ','    -',format('%10.3e',[A1]),
         format('%10.3e',[A2]),format('%10.3e',[A3]),format('%10.3e',[A4]));
      if (SCRB>0.001) then
         WRITELN (FrqFile,'- ',' CrA    ','    -',format('%10.3e',[B1]),
         format('%10.3e',[B2]),format('%10.3e',[B3]),format('%10.3e',[B4]));
    END;

    IF (Kr=3) THEN
    BEGIN
      if (SCRA>0.001) then
         WRITELN (FrqFile,'- ',' C3*    ','    -',format('%10.3e',[A1]),
         format('%10.3e',[A2]),format('%10.3e',[A3]),format('%10.3e',[A4]));
      if (SCRB>0.001) then
         WRITELN (FrqFile,'- ',' CrB    ','    -',format('%10.3e',[B1]),
         format('%10.3e',[B2]),format('%10.3e',[B3]),format('%10.3e',[B4]));
    END;
    IF (Kr=0) THEN
    BEGIN
      if (AA>0.001) and (SCRA>0.001) then
         WRITELN (FrqFile,'- ',' CrA    ','    -',format('%10.3e',[A1]),
         format('%10.3e',[A2]),format('%10.3e',[A3]),format('%10.3e',[A4]));
      if (BB>0.001) and (SCRB>0.001) then
         WRITELN (FrqFile,'- ',' CrB    ','    -',format('%10.3e',[B1]),
         format('%10.3e',[B2]),format('%10.3e',[B3]),format('%10.3e',[B4]));
      if (UU>0.001) and (SCRU>0.001) then
         WRITELN (FrqFile,'- ',' CrU    ','    -',format('%10.3e',[U1]),
         format('%10.3e',[U2]),format('%10.3e',[U3]),format('%10.3e',[U4]));
    END;

    if YY=NS then WRITELN (FrqFile,' #');
    WRITELN (FrqFile);

  end; {with DataMod do}
end; {procedure Frequency}
{------------------------}


procedure Waterbalances (var AAy,BBy,BYPy,DRRy,EPAy,EPBy,EPUy,FFy,
          HIGy,HOGy,IRAy,IRBy,PLCy,RAIy,SDAy,SDBy,SRIy,SROy,STAy,STBy,STUy,
          UUy,WELy,WTCy : real);
{-------------------------------------------------------------------------}
label 1, 3, 5;
var J1, J2 : byte;
    JJ, YR, Tst  : integer;
    CDWR, HCR, NET, PLCC, PX, STO, ZZ : real;
    DOWN, UPWA, DIFA, DIFB, DIFU, Rain : real;
BEGIN;
with DataMod do
BEGIN

//Setting initial values
  J1:=0;
  J2:=0;
  STO:=0;
  DIFC:=0;
  DIFP:=0;
  PLCC:=PLCy;
  Rain:=RAIy;
  YR:=DataMod.MonthNr;

//Checking surface drainage
  SDAz:=SDAy;
  SDBz:=SDBy;
  SROz:=SROy;
  if (DWT<0) and (SDAy>0) then
  begin
    if SDAy>0.9*(Rain+IrAy-DWT) then
       SDAz:=0.9*(Rain+IrAy-DWT);
    if SDAy<0 then SDAz:=-0.9*DWT;
  end;
  if (DWT>=0) and (SDAy>0) then
  begin
    if SDAz>0.75*(Rain+IrAy) then
       SDAz:=0.75*(Rain+IrAy);
    if SDAz<0 then SDAz:=0;
  end;
  if (DWT<0) and (SDBy>0) then
  begin
    if SDBz>0.9*(Rain+IrBy-DWT) then
       SDBz:=0.9*(Rain+IrBy-DWT);
    if SDBz<0 then SDBz:=-0.9*DWT;
  end;
  if (DWT>=0) and (SDBy>0) then
  begin
    if SDBy>0.75*(Rain+IrBy) then
       SDBz:=0.75*(Rain+IrBy);
    if SDBz<0 then SDBz:=0;
  end;
  if (DWT<0) and (SROy>0) then
  begin
    if SROy>0.9*(Rain+SRIy-DWT) then
       SROz:=0.9*(Rain+SRIy-DWT);
    if SROz<0 then SROz:=-0.9*DWT;
  end;
  if (DWT>=0) and (SROy>0) then
  begin
    if SROy>0.75*(Rain+SRIy) then
       SROz:=0.75*(Rain+SRIy);
    if SROz<0 then SROz:=0;
  end;
  if DWT<0 then DWT:=DWT+AAy*SDAz+BBy*SDBZ+(1-AAy-BBy)*SROz;

  IF NOT Warn1[YY] AND ((SDAz<>SDAy) or (SDBz<>SDBy) or (SROz<>SROy)) THEN
  BEGIN
    if (SDAz<>SDAy) then
    WRITELN (WarnFile,' The excessive surface drainage SDA in year :',YR:3,
                      ', season :',YY:2,' is reduced.');
    if (SDBz<>SDBy) then
    WRITELN (WarnFile,' The excessive surface drainage SDB in year :',YR:3,
                      ', season :',YY:2,' is reduced.');
    if (SROz<>SROy) then
    WRITELN (WarnFile,' The excessive surface runoff SRO in year :',YR:3,
                      ', season :',YY:2,' is reduced.');
   WRITELN (WarnFile);
   Warn1[YY]:=true;
  END;

//Choosing factor ZZ in dependance of DWT and CDW for determining
//capillary rise and adjustment of surface runoff
1: CDWR:=CDW-0.5*Dr;
   IF CDWR<=0 THEN
     ZZ:=1
   ELSE
   BEGIN
   ZZ:=(CDW-DWT)/CDWR;
   IF ZZ<0 THEN ZZ:=0;
   IF ZZ>1 THEN ZZ:=1;
   END;
//Adjustments for shallow water tabel
  IF DWT<Dr THEN PLCC:=0.5*PLCy;
  IF DWT<-0.2 THEN PLCC:=0;

//Determining actual evapotranspiration and capillary rise through
//AuxWBA with one tertiary subroutine
  AuxWBA (AAy,BBy,EPAy,EPBy,EPUy,IRAy,IRBy,Rain,
          SDAz,SDBz,SRIy,SROz,STAy,STBy,STUy,UUy,ZZ);

//Percolation losses in irrigated A fields
//in cub.m/season per sq.m irrigated A area
  PLA:=Rain+IRAy{-SstA}-EPAC-SDAz;
  IF (AAy<0.001) THEN PLA:=0;

//Setting zero values when fraction A area is very large
  IF (AAy>0.999) THEN
  BEGIN
    PLB:=0;
    PLU:=0;
    GOTO 3;
  END;

//Percolation losses in irrigated B fields
//in cub.m/season per sq.m irrigated B area
  PLB:=Rain+IRBy{-SstB}-EPBC-SDBz;
  IF (BBy<0.001) THEN PLB:=0;

//Setting zero values when fraction B area is very large
  IF (BBy>0.999) THEN
  BEGIN
    PLA:=0;
    PLU:=0;
    GOTO 3;
  END;

//Percolation losses in non irrigated U fields
//in cub.m/season per sq.m unirrigated U area
  PLU:=Rain{-SstU}-EPUC+SRIy-SROz;
  IF (UUy<0.001) THEN PLU:=0;

//Setting zero values when fraction U area is very large
  IF (UUy>0.999) THEN
  BEGIN
    PLA:=0;
    PLB:=0;
  END;

//Total amount of canal irrigation water including re-use
//in cub.m/season per sq.m total area
3: CIT:=PLCy+IRAy*AAy+IRBy*BBy;

//Amount of canal water excluding re-use in cub.m/season pr sq.m total area
  CIR:=CIT-DRRy-FFy*WELy;
(*
  IF NOT Warn1[YY] AND (CIR<-0.001) THEN
  BEGIN
    WRITELN (WarnFile,' The field irrigation IRA and/or IRB in year :',YR:3,
                      ', season :',YY:2,' does not');
    WRITELN (WarnFile,' incorporate all the re-used drain or well water.');
    WRITELN (WarnFile,'  The excess is added to the bypass (Io).');
    WRITELN (WarnFile);
    BYPy:=BYPy-CIR;
    CIR:=0;
    Warn1[YY]:=true;
  END;
  IF Warn1[YY] AND (CIR<-0.001) THEN
  BEGIN
    BYPy:=BYPy-CIR;
    CIR:=0;
  END;
*)
//Determining the subsurface drainage
  Tst:=30;
  if DataMod.TimeStep='Week' then Tst:=7;
  if DataMod.TimeStep='Day' then Tst:=1;
  HCR:=Dd-DWT;
  IF (HCR<=0) OR (Kd=0) THEN
  BEGIN
    DRA:=0;
    DRB:=0;
    DRC:=0;
  END ELSE
  BEGIN
    DRA:=(1-WTCy)*QH2*(HCR*HCR)*Tst;
    DRB:=(1-WTCy)*QH1*HCR*Tst;
    IF (DWT<=-0.1) THEN DRA:=DRA*2;
    DRC:=DRA+DRB;
  END;

  IF NOT Warn2[YY] AND (DRC<DRRy) THEN
  BEGIN
    WRITELN (WarnFile,' The total drainage in year :',YR:3,', season :',
                 YY:2,' is less than the amount of drainage.');
    WRITELN (WarnFile,' The drainage re-use (DRR) is reduced to equal'+
                      ' the drainage.');
   WRITELN (WarnFile);
   DRRy:=DRC;
   Warn2[YY]:=true;
  END;
  IF Warn2[YY] AND (DRC<DRRy) THEN DRRy:=DRC;

//Total capillary rise (CAT), percolation losses (PLT) and net recharge
//in cub.m/season per sq.m total area
  CAT:=CAA*AAy+CAB*BBy+CAU*UUy;
  PLT:=PLA*AAy+PLB*BBy+PLU*UUy;
  NET:=PLCC+PLT{+SstT}+HIGy-HOGy-WELy-CAT-DRC;

//Adjusting the watertable depth DWT stepwise to find equilibrium
//between NET and STO
  IF NET>STO THEN
  BEGIN
    J1:=1;
    JJ:=1;
  END ELSE
  BEGIN
    J2:=1;
    JJ:=-1;
  END;
  IF (J1=1) AND (J2=1) THEN GOTO 5;
  if abs(Net-Sto)<0.001 then goto 5;
  DWT:=DWT-JJ*0.001;

//Finding the applicable effective porespace in relation to depth of watertable
  PX:=1;
  IF (DWT>0) AND (DWT<=Dr) THEN PX:=Per;
  IF (DWT>Dr) AND (DWT<=Dr+Dx) THEN PX:=Pex;
  IF (DWT>Dr+Dx) THEN PX:=Peq;

//Storage due to stepwise change of the watertable
  STO:=STO+JJ*0.001*PX;
  GOTO 1;

//Provisions for waterlogging (DWT<O) NECESSARY ???
5: if PLA<0 then PLA:=0;
   if PLB<0 then PLB:=0;
   if PLU<0 then PLU:=0;
   if PLT<0 then PLT:=0;
   if CAA<0 then CAA:=0;
   if CAB<0 then CAB:=0;
   if CAU<0 then CAU:=0;
   if CAT<0 then CAT:=0;

(*
   IF (DWT<0) AND (DWT0<0) THEN
   BEGIN
     DIFA:=0;
     IF (PLA>DOWN) THEN
     BEGIN
       DIFA:=PLA-DOWN;
//       SstA:=DIFA;
       PLA:=DOWN;
     END;
     DIFB:=0;
     IF (PLB>DOWN) THEN
     BEGIN
       DIFB:=PLB-DOWN;
//       SstB:=DIFB;
       PLB:=DOWN;
     END;
     DIFU:=0;
     IF (PLU>DOWN) THEN
     BEGIN
       DIFU:=PLU-DOWN;
//       SstU:=DIFU;
       PLU:=DOWN;
     END;
     DIFP:=DIFP+AAy*DIFA+BBy*DIFB+UUy*DIFU;
   END;
*)
(*
   IF (DWT>=0) AND (DWT0<0) THEN
   BEGIN
     PLA:=PLA+DIFP;
     PLB:=PLB+DIFP;
     PLU:=PLU+DIFP;
   END;
*)
(*
   IF (DWT<0) AND (DWT0<0) THEN
   BEGIN
     DIFA:=0;
     IF (CAA>UPWA) THEN
     BEGIN
       DIFA:=CAA-UPWA;
       CAA:=UPWA;
     END;
     DIFB:=0;
     IF (CAB>UPWA) THEN
     BEGIN
       DIFB:=CAB-UPWA;
       CAB:=UPWA;
     END;
     DIFU:=0;
     IF (CAU>UPWA) THEN
     BEGIN
       DIFU:=CAU-UPWA;
       CAU:=UPWA;
     END;
     DIFC:=DIFC+AAy*DIFA+BBy*DIFB+UUy*DIFU;
   END;
*)
(*
   IF (DWT>=0) AND (DWT0<0) THEN
   BEGIN
     CAA:=CAA+DIFC;
     CAB:=CAB+DIFC;
     CAU:=CAU+DIFC;
     DIFC:=0
   END;
*)
   IF PLA>CAA THEN
   BEGIN
     PLA:=PLA-CAA;
     CAA:=0;
   END;
   IF PLB>CAB THEN
   BEGIN
     PLB:=PLB-CAB;
     CAB:=0;
   END;
   IF PLU>CAU THEN
   BEGIN
     PLU:=PLU-CAU;
     CAU:=0;
   END;
   IF CAA>PLA THEN
   BEGIN
     CAA:=CAA-PLA;
     PLA:=0;
   END;
   IF CAB>PLB THEN
   BEGIN
     CAB:=CAB-PLB;
     PLB:=0;
   END;
   IF CAU>PLU THEN
   BEGIN
     CAU:=CAU-PLU;
     PLU:=0;
   END;

   IF AAy<0.001 THEN PLA:=0;
   IF BBy<0.001 THEN PLB:=0;
   IF UUy<0.001 THEN PLU:=0;
   IF AAy<0.001 THEN CAA:=0;
   IF BBy<0.001 THEN CAB:=0;
   IF UUy<0.001 THEN CAU:=0;

//Redefining total capillary rise (CAT) and percolation (PLT)
   CAT:=CAA*AAy+CAB*BBy+CAU*UUy;
   PLT:=PLA*AAy+PLB*BBy+PLU*UUy;

END; {with DataMod do}
END; {procedure Waterbalances}
{----------------------------}


//Determining actual evapotranspiration and capillary rise through
//AuxWBA with one tertiary subroutine: AuxWBA1  (under Waterbalances)
procedure AuxWBA (var AA1,BB1,EPA1,EPB1,EPU1,IRA1,IRB1,RAI1,
          SDA1,SDB1,SRI1,SRO1,STA1,STB1,STU1,UU1,ZZ1 : real);
{-----------------------------------------------------------}
begin with DataMod do
begin

//Determining actual evapotransp. and cap. rise in unirr. land
  IF UU1<0.001 THEN
  BEGIN
    EPUC:=0;
    PLU:=0;
    CAU:=0;
    SRO1:=0;
  END ELSE
      AuxWBA1 (CAU,EPU1,EPUC,SRI1,RAI1,SRO1,STU1,ZZ1);

//Determining act. evapotr. and cap. rise in irrigated A land
  IF AA1<0.001 THEN
  BEGIN
    EPAC:=0;
    PLA:=0;
    CAA:=0;
    SDA1:=0;
  END ELSE
      AuxWBA1 (CAA,EPA1,EPAC,IRA1,RAI1,SDA1,STA1,ZZ1);

//Determining act. evapotr. and cap. rise in irrigated B land
  IF BB1<0.001 THEN
  BEGIN
    EPBC:=0;
    PLB:=0;
    CAB:=0;
    SDB1:=0;
  END ELSE
      AuxWBA1 (CAB,EPB1,EPBC,IRB1,RAI1,SDB1,STB1,ZZ1);

end; {with DataMod do}
end; {procedure AuxWBA}
{---------------------}


//Determining act. evapotr. and cap. rise
procedure AuxWBA1 (var CA,EP0,EP1,IR,RAIN,SD,ST,ZZ2 : real);
{----------------------------------------------------------}
var ES:real;
begin

  ES:=RAIN+IR-SD;
  IF ST>0 THEN
  BEGIN
    IF (ES>=EP0/ST) OR (DWT<0) THEN
    BEGIN
      EP1:=EP0;
      CA:=0;
    END ELSE
    BEGIN
      EP1:=ST*ES+ZZ2*(EP0-ST*ES);
      CA:=EP1-ES;
      IF CA<0 THEN CA:=0;
    END;
  END;

end; {procedure AuxWBA1}
{----------------------}


procedure SaltBalances (var AAy,BBy,DRRy,FFy,HIGy,HOGy,IRAy,IRBy,PLCy,RAIy,
                        SDAy,SDBy,SRIy,SROy,UUy,WELy : real);
{-------------------------------------------------------------------------}
var Q1, Q2, SDLA, SDLB, SDLU, TotIrr, ZIRR, {CIRT, IRA, IRB, }
    INFA, INFB, INFU, SDAA, SDBB, SROO, RAIN, PLCC, DOWN, UPWA,
    SCX, TSP, SCMA, SCMB, SCMU, {TIR, TDR, TSIU, TSCU, TSI, TSO,}
    {TSIA, TSIB, TCAA, TCAB, TSCA, TSCB, TPLA, TPLB,} VF, VDD, VUS,
    SCTM, SCLM, SCUM, SCRy                                          : real;
    Accum, DUM : real;

BEGIN with DataMod do
begin

//Salt concentration of the irrigation (ZIR) drainage (ZDR) and well water (ZWL)
  ZDR:=0;
  IF (Kd=1) AND (DRC>0.001) THEN ZDR:=(DRA*SCU+DRB*SCL)*Flx/DRC;
  ZWL:=Flq*SCA;
  IF WELy<0.001 THEN ZWL:=0;
  ZIR:=ZIC;
	Q1:=CIT-DRRy-FFy*WELy;
 	Q2:=FFy*WELy;
	TotIrr:=CIT+FFy*WEly+DRRy;
  ZIRR:=ZIR;
  if TotIrr>0.001 THEN ZIR:=(Q1*ZIC+Q2*ZWL+DRRy*ZDR)/(TotIrr);
//  if ZIR0<ZIR THEN ZIR0:=ZIR;

//Surface drainage leaching efficiency
  SDLA:=(10+SCRA)/100;
  SDLB:=(10+SCRB)/100;
  SDLU:=(10+SCRU)/100;

//Infiltration,rainfall and surface drainage provision for waterlogging
  INFA:=IRAy;
  INFB:=IRBy;
  INFU:=SRIy;
  SDAA:=SDAy;
  SDBB:=SDBy;
  SROO:=SROy;
  PLCC:=PLCy;
  RAIN:=RaiY;
  DOWN:=HOGy+WELy+DRC-HIGy;
  UPWA:=-Down;
  if Down<0 then Down:=0;
  if UPWA<0 then UPWA:=0;
  if DWT<0 then
  begin
    INFA:=Down;
    INFB:=Down;
    INFU:=Down;
  end;
  IF DWT<Dr THEN PLCC:=0.5*PLCy;
  Salt:=0;
  if (DWT<0) then
  begin
    SCRy := AAy*SCRA+BBy*SCRB+UUy*SCRU;
    Accum:=TotIrr*ZIR {includes reuse} +(INFU-SROO)*SCRU+UPWA*Flr*SCRy-DOWN*CSW0;
    if DWT0>0 then
       Accum:=(TotIrr*ZIR+(INFU-SROO)*SCRU)*-DWT/(DWT0);
    DUM:=TotIrr+INFU-SROO+UPWA-DOWN-DWT;
    if DUM>0.001 then
       CSW:=CSW0+(CSW0*-DWT+Accum)/Dum
    else CSW:=0.001;
    if CSW>100 then CSW:=100;
    if CSW>ZIR then ZIR:=CSW;
    CSW0:=CSW;
    SALT:=CSW*-DWT;
  end;
  if (DWT>0) and (DWT0<0) then
  begin
    ZIR:=CSW;
    CSW:=0;
    CSW0:=CSW;
  end;

//Salt concentration of water in the transition zone depending on Kd
  IF Kd=0 THEN SCX:=SCT
  ELSE SCX:=SCU;

//Salt concentrations in the irrigated areas (SCRA=A area, SCRB=B area)
//and in the unirrigated area (SCRU) when Kr=0
  IF Kr=0 THEN
  BEGIN
    AuxSB1 (DOWN,UPWA,INFA,INFB,INFU,Rain,SCMA,SCMB,SCMU,SCX,SDAA,SDBB,
            SDLA,SDLB,SDLU,SROO);
//Total salt percolating
    TSP:=Flr*(PLA*SCMA*AAy+PLB*SCMB*BBy+PLU*SCMU*UUy);
//    IF DWT<0 THEN TSP:=Flr*(DOWN*SCMA*AAy+DOWN*SCMB*BBy+DOWN*SCMU*UUy);
  END;

//Total irrigation, surface drainage
//  TIR:=INFA*AAy+INFB*BBy+INFU*UUy;
//  TDR:=SDAA*AAy+SDBB*BBy+SROO*UUy;

//Determining the vertical upward seepage from or the vertical downward
//drainage to the aquifer
  VF:=HIGy-HOGy-WELy;
  IF VF<0 THEN
  BEGIN
    VDD:=ABS(VF);
    VUS:=0;
  END ELSE
  BEGIN
    VUS:=VF;
    VDD:=0;
  END;

//Salt concentration in of the water in the transition zone (SCT) when
//there is no drainage system (Kd=0)
  IF Kd=0 THEN
     AuxSB4A (PLCC,SCTM,TSP,VDD,VUS)
  ELSE
//Salt concentration in the upper (SCU) and lower (SCL) transition zone
//when a drainage system is present (Kd=1)
  AuxSB4B (PLCC,SCA,SCL,SCLM,SCU,SCUM,TSP,VDD,VUS);

//Salt concentration of the drainage water
  ZDR:=0;
  IF (Kd=1) AND (DRC>0.001) THEN
      ZDR:=(DRA*SCUM+DRB*SCLM)*Flx/DRC;

//Salt concentration of the water in the aquifer (SCA)
  AuxSB5 (HIGy,HOGy,PLCC,PLT,SCLM,SCTM,VDD,VUS,WELy,ZIG,ZIR);
//  IF (DWT>=0) AND (DWT0<0) THEN ZIR:=ZIRR+SALT/(TIR+RAIN-TDR-DWT0);
//  IF (DWT<0) AND (DWT0>0) THEN ZIR:=ZIRR;
  CiNa:=0;
//  IF (DWT>=0) AND (DWT0>=0) THEN
//      IF (INFA*AAy=0) AND (INFB*BBy=0) THEN CiNa:=1;
  IF DWT>=0 THEN SALT:=0;
  ZIR:=ZIRR;

end; {with DataMod do}
END; {SaltBalances}
{-----------------}


//AuxSB1 is part of SaltBalances}
//Salt concentrations in the irrigated and unirrigated areas
procedure AuxSB1 (var DOWNx,UPWAx,INFAx,INFBx,INFUx,RAINx,SCMAx,SCMBx,SCMUx,
                  SCXx,SDAx,SDBx,SDLAx,SDLBx,SDLUx,SROx : real);
{-----------------------------------------------------------------------------}
label 1,2,3;
var SCRIA, SCRIB, SCRIU, ACC, ACCI, ACCO : real;

BEGIN with DataMod do
begin

//Setting initial values
  SCRIA:=SCRA0;
  SCRIB:=SCRB0;
  SCRIU:=SCRU0;
//Salt accumulation (ACC) and concentration (SCRA) in the rootzone of A area
1: ACCI:=INFAx*ZIR+RAINx*ZRA+CAA*Flx*SCXx{+SSIx};
   ACCO:=SDAx*(SDLAx*SCRIA)+SCRIA*Flr*PLA;
   ACC:=ACCI-ACCO;
   SCRA:=(SCRA0*Ptr*Dr+ACC)/(Ptr*Dr);
   IF (SCRA=0) OR (SCRA0=0) THEN
   BEGIN
     SCMAx:=0;
     GOTO 2;
   END;
//Finding the average salt concentration of rootzone of A stepwise
   IF ACC<0 THEN
   BEGIN
     IF SCRA<=0 THEN SCRA:=0.1*SCRA0;
     SCMAx:=sqrt(SCRA0*SCRA);
     SCRIA:=SCRIA-0.01*SCRA0;
     IF SCRIA<=SCMAx THEN GOTO 2;
     GOTO 1;
   END ELSE
     SCMAx:=(SCRA0+SCRA)/2;

//Salt accumulation (ACC) and concentration (SCRB) in the rootzone of B area
2: ACCI:=INFBx*ZIR+RAINx*ZRA+CAB*Flx*SCXx;
   ACCO:=SDBx*SDLBx*SCRIB+SCRIB*Flr*PLB;
   IF DWT<0 then ACCO:=SDBx*SDLBx*SCRIB+SCRIB*Flr*DOWNx;
   ACC:=ACCI-ACCO;
   SCRB:=SCRB0+ACC/(Ptr*Dr);
   IF (SCRB=0) OR (SCRB0=0) THEN
   BEGIN
     SCMBx:=0;
     GOTO 3;
   END;
//Finding the average salt concentration of rootzone of B stepwise
   IF ACC<0 THEN
   BEGIN
     IF SCRB<=0 THEN SCRB:=0.1*SCRB0;
     SCMBx:=sqrt(SCRB0*SCRB);
     SCRIB:=SCRIB-0.01*SCRB0;
     IF SCRIB<=SCMBx THEN GOTO 3;
     GOTO 2;
   END ELSE
     SCMBx:=(SCRB0+SCRB)/2;

//Salt accumulation (ACC) and concentration (SCRU) in the rootzone of U area
3: ACCI:=INFUx*ZIR+RAINx*ZRA+CAU*Flx*SCXx;
   ACCO:=SROx*SDLUx*SCRIU+SCRIU*Flr*PLU;
   IF DWT<0 then ACCO:=SROx*SDLUx*SCRIU+SCRIU*Flr*DOWNx;
   ACC:=ACCI-ACCO;
   SCRU:=SCRU0+ACC/(Ptr*Dr);
   IF (SCRU=0) OR (SCRU0=0) THEN
   BEGIN
     SCMUx:=0;
     exit;
   END;
//Finding the average salt concentration of rootzone of B stepwise
   IF ACC<0 THEN
   BEGIN
     IF SCRU<=0 THEN SCRU:=0.1*SCRU0;
     SCMUx:=sqrt(SCRU0*SCRU);
     SCRIU:=SCRIU-0.01*SCRU0;
     IF SCRIU<=SCMUx THEN exit;
     GOTO 3;
   END ELSE
     SCMBx:=(SCRB0+SCRB)/2;

end; {with DataMod do}
END; {procedure AuxSB1}
{---------------------}


//AuxSB2 is part of SaltBalances}
//Salt concentration in the root zone of A, B and/or U areas when
//the rotation key (Kr) is 1, 2 or 3
procedure AuxSB2 (var AUB,SCR1,SCM1,SC01,SCR2,SCM2,SC02,TSC1,TSC2,TSI1,TSI2,
                      TPL1,TPL2: real);
{--------------------------------------------------------------------------}
label 1, 2, 3;
var ACC, SRI1, SRI2 : real;

BEGIN with DataMod do
begin

//Setting initial values
   SRI1:=SC01;
   SRI2:=SC02;
   IF AUB>0.999 THEN
   BEGIN
     SCR1:=SC01;
     GOTO 3
   END;

//Salt accumulation and concentration in the rootzone, mixed area
1: ACC:=TSI1-TPL1*Flr*SRI1+TSC1;
   SCR1:=SC01+ACC/(Ptr*Dr);
   IF (SCR1=0) OR (SC01=0) THEN
   BEGIN
     SCM1:=0;
     GOTO 2;
   END;

//Finding the average salt conc. of rootzone stepwise, mixed area
   IF ACC<0 THEN
   BEGIN
     IF SCR1<=0 THEN SCR1:=0.1*SC01;
     SCM1:=sqrt(SC01*SCR1);
     SRI1:=SRI1-0.01*SC01;
     IF SRI1<=SCM1 THEN GOTO 2;
     GOTO 1;
   END ELSE
     SCM1:=(SC01+SCR1)/2;

2: IF AUB<0.001 THEN
   BEGIN
     SCR2:=SC02;
     exit;
   END;

//Salt accumulation and concentration in the rootzone, fixed area
3: ACC:=TSI2-TPL2*Flr*SRI2+TSC2;
   SCR2:=SC02+ACC/(Ptr*Dr);
   IF (SCR2=0) OR (SC02=0) THEN
   BEGIN
     SCM2:=0;
     exit;
   END;

//Finding the average salt conc. in the rootzone stepwise, fixed area
   IF ACC<0 THEN
   BEGIN
     IF SCR2<=0 THEN SCR2:=0.1*SC02;
     SCM2:=sqrt(SC02*SCR2);
     SRI2:=SRI2-0.01*SC02;
     IF SRI2<=SCM2 THEN exit;
     GOTO 3
   END ELSE
     SCM2:=(SC02+SCR2)/2;

end; {with DataMod do}
END; {procedure AuxSB2}
{---------------------}


//AuxSB3 is part of SaltBalances}
//Salt concentration in the rootzone (SCRA) when full rotation occurs (Kr=4)
procedure AuxSB3 (var PLF,SCRAx,SCMAx,TSIx : real);
{-------------------------------------------------}
label 1;
var ACCA, SCIA : real;

BEGIN with DataMod do
begin

//Setting initial value
        SCIA:=SCRA0;

//Salt accumulation and concentration in the rootzone
1: ACCA:=TSIx-PLF*Flr*SCIA;
   SCRAx:=SCRA0+ACCA/(Ptr*Dr);

//Finding the average salt concentration of rootzone of total irrigated
//area stepwise
   IF ACCA<0 THEN
   BEGIN
     IF SCRAx<=0 THEN SCRAx:=0.1*SCRA0;
     SCMAx:=sqrt(SCRA0*SCRAx);
     SCIA:=SCIA-0.01*SCRA0;
     IF SCIA<=SCMAx THEN exit;
     GOTO 1;
   END ELSE
     SCMAx:=(SCRA0+SCRAx)/2;

end; {with DataMod do}
END; {procedure AuxSB3}
{---------------------}


//AuxSB4A is part of SaltBalances}
//Salt concentration in of the water in the transition zone (SCT) when
//there is no drainage system (Kd=0)
procedure AuxSB4A (var PLC,SCTMx,TSPx,VDDx,VUSx : real);
{------------------------------------------------------}
label 1;
var  ACC,SCI,SCTT : real;

BEGIN with DataMod do
begin

//Setting initial values
  SCI:=SCT;
  SCTT:=SCT;

//Salt accumulation and concentration (SCT) in the transition zone
1: ACC:=TSPx+PLC*ZIR+VUSx*Flq*SCA-(CAT+VDDx)*Flx*SCTT;
   IF DWT>=Dr+Dx THEN ACC:=TSPx-PLT*Flx*SCTT-CAT*(Flx*SCTT-Flq*SCA);
   SCT:=SCI+ACC/(Ptx*Dx);
   IF (SCT=0) OR (SCI=0) THEN
   BEGIN
     SCTMx:=0;
     exit;
   END;
//Finding the average salt concentration stepwise
  IF ACC<0 THEN
  BEGIN
    IF SCT<=0 THEN SCT:=0.1*SCI;
    SCTMx:=sqrt(SCI*SCT);
    SCTT:=SCTT-0.01*SCI;
    IF SCTT<SCTMx THEN exit;
    GOTO 1;
  END ELSE
    SCTMx:=(SCI+SCT)/2;

end; {with DataMod do}
END; {procedure AuxSB4A}
{----------------------}


//AuxSB4B is part of SaltBalances}
//Salt concentration in the upper (SCU) and lower (SCL) transition zone
//when a drainage system is present (Kd=1)
procedure AuxSB4B (var PLC,SCAx,SCLx,SCLMx,SCUx,SCUMx,TSPx,VDDx,VUSx : real);
{---------------------------------------------------------------------------}
label 1, 2, 3;
var VUX, VDX, VAX, VUB, SCUU, SCI, ACC, PO, SCLL, TR : real;

BEGIN with DataMod do
begin

//Auxiliary waterbalance factors
  VUX:=VUSx-DRB;
  IF VUX<0 THEN VUX:=0;
  VDX:=PLT-DRA;
//  VDX:=PLT;
  IF VDX<0 THEN VDX:=0;
  VAX:=CAT+VDX+DRA;
  VUB:=VUX+VDDx+DRB;
//Starting value of the salt concentration in the upper part of
//the transition zone used for iterative calculations
  SCUU:=SCU;
  SCI:=SCUU;
//Salt accumulation and concentration (SCU) in the upper part of
//the transition zone
1: ACC:=TSPx+VUX*Flx*SCL-VAX*Flx*SCUU;
//   IF DWT>=Dd THEN
//      ACC:=TSPx-PLT*Flx*SCUU+CAT*Flx*(SCL-SCU);
   PO:=Ptx*(Dd-Dr);
   SCU:=SCI+ACC/PO;
   IF (SCU=0) OR (SCI=0) THEN
   BEGIN
     SCUMx:=0;
     GOTO 2;
   END;
//Finding the average salt concentration in the upper part of the
//transition zone stepwise
  IF ACC<0 THEN
  BEGIN
    IF SCU<=0 THEN SCU:=0.1*SCI;
    SCUMx:=sqrt(SCI*SCU);
    SCUU:=SCUU-0.01*SCI;
    IF SCUU<SCUMx THEN GOTO 2;
    GOTO 1;
  END ELSE
    SCUMx:=(SCI+SCU)/2;

//Starting value of the salt concentration in the lower part of
//the transition zone used for iterative calculations
2: SCLL:=SCL;
   SCI:=SCLL;
//Salt accumulation and concentration (SCL) in lower transition zone
3: ACC:=VDX*Flx*SCUMx+PLC*ZIR+VUSx*Flq*SCA-VUB*Flx*SCLL;
   IF DWT>=Dr+Dx THEN
      ACC:=PLT*Flx*(SCUMx-SCLL)+CAT*(Flq*SCA-Flx*SCLL);
   TR:=Dr+Dx-Dd;
   PO:=Ptx*TR;
   SCL:=SCI+ACC/PO;
   IF (SCL=0) OR (SCI=0) THEN
   BEGIN
     SCLMx:=0;
     exit;
   END;
//Finding the average salt concentration in the lower part of
//the transition zone stepwise
  IF ACC<0 THEN
  BEGIN
    IF SCL<=0 THEN SCL:=0.1*SCI;
    SCLMx:=sqrt(SCI*SCL);
    SCLL:=SCLL-0.01*SCI;
    IF SCLL<SCLMx THEN exit;
    GOTO 3;
  END ELSE
    SCLMx:=(SCI+SCL)/2;

end; {with DataMod do}
END; {procedure AuxSB4B}
{----------------------}


//AuxSB5 is part of SaltBalances}
//Salt concentration of the water in the aquifer (SCA)
procedure AuxSB5 (var HIG,HOG,PLC,PLF,SCLMx,SCTMx,VDDx,VUSx,WELx,
                      ZIGx,ZIRx : real);
{---------------------------------------------------------------}
label 1;
var ACC,ACCU,SCAA,SCI,SCM,SCX : real;

BEGIN with DataMod do
begin

//Determining salinity of the transition zone
  SCX:=SCTMx;
  IF Kd=1 THEN SCX:=SCLMx;
//Starting value of the salt concentration in the aquifer used for
//iterative calculations
  SCAA:=SCA;
  SCI:=SCA;
//Salt accumulation (ACC) and concentration (SCA) in the aquifer
1: ACCU:=HIG*ZIG-(HOG+WELx*Flq)*SCAA;
  ACC:=ACCU+VDDx*Flx*SCX-VUSx*Flq*SCAA;
  IF DWT>Dr+Dx THEN ACC:=ACCU+PLF*Flx*SCX+PLC*ZIR-CAT*Flq*SCAA;
  SCA:=SCI+ACC/(Ptq*Dq);
//Finding the average salt concentration in the aquifer stepwise
  IF ACC<0 THEN
  BEGIN
    IF SCA<0 THEN SCA:=0.1*SCI;
    SCM:=sqrt(SCI*SCA);
    SCAA:=SCAA-0.01*SCI;
    IF SCAA<SCM THEN exit;
    GOTO 1;
  END;
  
end; {with DataMod do}
END; {procedure AuxSB5}
{---------------------}


//To determine field irrigation efficiencies, canal irrigation efficiencies,
//and sufficiencies of irrigation water
procedure Efficiency (var AAy,BBy,EPAy,EPBy,IRAy,IRBy,RAIy : real);
{-----------------------------------------------------------------}

BEGIN

//Field irrigation efficiency in A area
  EFA:=0;
  IF IRAy>0.001 THEN EFA:=(EPAC-CAA)/(IRAy+RAIy);
  IF EFA>1 THEN EFA:=1;
//Field irrigation efficiency in B area
  EFb:=0;
  IF IRby>0.001 THEN EFb:=(EPbC-CAb)/(IRby+RAIy);
  IF EFB>1 THEN EFB:=1;
//Overall irrigation efficiency
  EFT:=0;
  IF CIT>0.001 THEN
     EFT:=((EPAC-CAA)*AAy+(EPBC-CAB)*BBy)/(CIT+RAIy);
  IF EFT>1 THEN EFT:=1;
//Sufficiency of irrigation water in A area
  SUA:=0;
  IF (EPAC>0.001) AND (EPAy>0.001) THEN SUA:=EPAC/EPAy;
//Sufficiency of irrigation water in B area
  SUB:=0;
  IF (EPBC>0.001) AND (EPBy>0.001) THEN SUB:=EPBC/EPBy;

END; {procedure Efficiency}
{-------------------------}


//end of UCalculate
end.

